<?php

namespace app\models;

use Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;
use app\models\Hivlinkage;
use app\base\Converter;

/**
 * HivlinkageSearch represents the model behind the search form about `app\models\Hivlinkage`.
 */
class HivlinkageSearch extends Hivlinkage
{
    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['hiv_linkage_id', 'hiv_linkage_q2','hiv_linkage_q2a','hiv_linkage_q4', 'hiv_linkage_q6', 'hiv_linkage_q8', 'create_time', 'create_user', 'update_time', 'update_user'], 'integer'],
            [['hiv_linkage_survey', 'hiv_linkage_part_id', 'hiv_linkage_q1', 'hiv_linkage_q3', 'hiv_linkage_q5', 'hiv_linkage_q7a', 'status','record_date'], 'safe'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = Hivlinkage::find();

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
			'sort'=>[
                'defaultOrder'=>['record_date'=> SORT_DESC],
            ],
        ]);
     if(empty($params))
            $params = Yii::$app->request->post();
        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'hiv_linkage_id' => $this->hiv_linkage_id,
			'create_time' => $this->create_time,
            'create_user' => $this->create_user,
            'update_time' => $this->update_time,
            'update_user' => $this->update_user,
            'record_date' => Converter::toUnixTimeformat($this->record_date),
        ]);

        $query->andFilterWhere(['like', 'hiv_linkage_survey', $this->hiv_linkage_survey])
            ->andFilterWhere(['like', 'hiv_linkage_part_id', $this->hiv_linkage_part_id])
            ->andFilterWhere(['like', 'hiv_linkage_q1', $this->hiv_linkage_q1])
			->andFilterWhere(['like', 'hiv_linkage_q2a', $this->hiv_linkage_q2a])
            ->andFilterWhere(['like', 'hiv_linkage_q3', $this->hiv_linkage_q3])
            ->andFilterWhere(['like', 'hiv_linkage_q5', $this->hiv_linkage_q5])
            ->andFilterWhere(['like', 'hiv_linkage_q7a', $this->hiv_linkage_q7a])
            ->andFilterWhere(['like', 'status', $this->status]);

        return $dataProvider;
    }
}